package baka.dataflow;

import java.util.Vector;

/**
 * Reprezentuje ruru medzi blokmi, po ktorej sa transferuju data
 * @author madda
 */
public class DataChannel {

    Vector<Packet> storage;
    Vector<Packet> cache;
    int type; // 0 unlimited 1 limited 2 Memory

    public DataChannel(int type) {
        storage = new Vector<Packet>();
        cache = new Vector<Packet>();
        this.type = type;
    }

    public Packet read() {
        if (isEmpty()) {
            return null;
        }
        Packet ret = storage.firstElement();
        System.out.println("Citam Packet."+ret.getTextContent());
        if (type != 2) {
            storage.removeElementAt(0);
            System.out.println("Odstranujem precitany packet");
        }
        return ret;
    }

    public void write(Packet p) {
        cache.add(p);
        System.out.println("zapisal som packet do chache:" + p.getTextContent());
        System.out.println("CACHE");
        for (int i = 1; i < cache.size(); i++) {
            Packet temp = cache.elementAt(i);
            System.out.println("Packet" + i + " : " + temp.getTextContent());
        }
    }

    public void commit() {
        System.out.println("VYPISUJEM OBSAH DATOVODU ktory je type:" + type);
        System.out.println("CACHE");
        for (int i = 1; i < cache.size(); i++) {
            Packet temp = cache.elementAt(i);
            System.out.println("Packet" + i + " : " + temp.getTextContent());
        }
        storage.addAll(cache);
        cache.clear();
        if (type == 1 || type == 2) {
            System.out.println("upravujem kapacitu");
            if (storage.size() > 0) {
                Packet temp = storage.lastElement();
                storage.clear();
                storage.add(temp);
            }
        }
        System.out.println("STORAGE");
        for (int i = 1; i < storage.size(); i++) {
            Packet temp = storage.elementAt(i);
            System.out.println("Packet" + i + " : " + temp.getTextContent());
        }
    }

    public void placeAtBegining(Packet p) {
        storage.add(0, p);
    }

    public boolean isEmpty() {
        return storage.isEmpty();
    }
}
