/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.manipulation;

import baka.dataflow.DataBlock;
import java.awt.event.ActionEvent;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class Splitter extends DataBlock {

    String delimiter = "";
    JTextField delimiterField;
    JTextField outputcountField;
    String outputCounts = "";
    boolean sendLineEnds = false;
    JCheckBox sendEndsCheckbox;

    public Splitter() {
        this.category = "manipulation";
        this.type = "Splitter";
        this.description = "Splits input by delmiter parameter, and send specified number of subpieces into each output.";
        this.maxInputCount = 1;
        constructProperties();
        this.propertiesPanel.setName(this.type);
    }

    @Override
    public void constructProperties() {
        super.constructProperties();
        delimiterField = new JTextField(delimiter);
        //glueField.addActionListener(this);
        delimiterField.getDocument().addDocumentListener(new DocumentListener() {

            public void insertUpdate(DocumentEvent e) {
                change();
            }

            public void removeUpdate(DocumentEvent e) {
                change();
            }

            public void changedUpdate(DocumentEvent e) {
                change();
            }

            public void change() {
                delimiter = delimiterField.getText();
            }
        });
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Delimiter"), delimiterField));
        outputcountField = new JTextField(delimiter);
        outputcountField.getDocument().addDocumentListener(new DocumentListener() {

            public void insertUpdate(DocumentEvent e) {
                change();
            }

            public void removeUpdate(DocumentEvent e) {
                change();
            }

            public void changedUpdate(DocumentEvent e) {
                change();
            }

            public void change() {
                outputCounts = outputcountField.getText();
            }
        });
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("OutputCounts (1;3;...)"), outputcountField));

        this.sendEndsCheckbox = new JCheckBox();
        this.sendEndsCheckbox.setActionCommand("lineEnds");
        this.sendEndsCheckbox.addActionListener(this);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Send line ends"), sendEndsCheckbox));
    }

    @Override
    public void processInput() {
        String line = "";
        if ((line = inputBus.readSpecific(0)) != null) {
            String[] pieces = null;
            if (delimiter.trim().equals("")) {
                pieces = line.split(" ");
            } else {
                pieces = line.split(delimiter);
            }
            System.out.println("Pieces:");
            for (String word : pieces) {
                System.out.println(word);
            }
            String[] counts = outputCounts.split(";");
            System.out.println("Counts:");
            for (String word : counts) {
                System.out.println(word);
            }
            String separator = System.getProperty("line.separator");
            int sent = 0;
            int sentBlocks = 0;
            for (int i = 0; i < counts.length; i++) {
                int sendToOutput = Integer.parseInt(counts[i]);
                for (int j = sent; j < sendToOutput; j++) {
                    if (j == pieces.length) {
                        break;
                    }
                    System.out.println("posielam do id:" + i + " kusok:" + pieces[j]);
                    outputBus.writeSpecific(i, pieces[j]);
                }
                if (sendLineEnds) {
                    outputBus.writeSpecific(i, separator);
                }
                sent += sendToOutput;
                sentBlocks++;
            }
            if ((sentBlocks < this.outputCount) && (sent < pieces.length)) {
                for (int i = sent; i < pieces.length; i++) {
                    System.out.println("posielam do id:" + sentBlocks + " kusok:" + pieces[i]);
                    this.outputBus.writeSpecific(sentBlocks, pieces[i]);
                }
                if (sendLineEnds) {
                    outputBus.writeSpecific(sentBlocks, separator);
                }
            }
        }
    }

    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);
        Attr delimiterA = doc.createAttribute("delimiter");
        delimiterA.setValue(this.delimiter);
        e.setAttributeNode(delimiterA);

        Attr outputCountsA = doc.createAttribute("outputCounts");
        outputCountsA.setValue(this.outputCounts);
        e.setAttributeNode(outputCountsA);

        Attr sendLineEndsA = doc.createAttribute("sendLineEnds");
        sendLineEndsA.setValue(String.valueOf(this.sendLineEnds));
        e.setAttributeNode(sendLineEndsA);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        this.delimiter = e.getAttribute("delimiter");
        this.outputCounts = e.getAttribute("outputCounts");
        String sendLineEndsA = e.getAttribute("sendLineEnds");
        if (sendLineEndsA.equals("true")) {
            this.sendLineEnds = true;
        } else {
            this.sendLineEnds = false;
        }
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.outputcountField.setText(this.outputCounts);
        this.delimiterField.setText(this.delimiter);
        this.sendEndsCheckbox.setSelected(this.sendLineEnds);
    }

    @Override
    public void resetBlockState() {
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getActionCommand().equals("lineEnds")) {
            this.sendLineEnds = this.sendEndsCheckbox.isSelected();
        }
    }

    @Override
    public void finalizeBlockWork() {
    }
}
