/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.source;

import baka.dataflow.*;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileFilter;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class DirectoryReader extends DataBlock implements ActionListener {

    private String directoryPath = "";
    private File[] directoryConent;
    private boolean hasInput;
    private int pos = 0;
    private JFileChooser fc;
    JTextField choosedDirectory;

    public DirectoryReader(String directory) {
        this.maxInputCount = 0;
        this.inputCount = 0;
        this.type = "DirectoryReader";
        this.category = "source";
        this.description = "Reads directory content, search for JPEG files.";
        constructProperties();
        this.propertiesPanel.setName(this.type);

        choosedDirectory = new JTextField(directoryPath);
        choosedDirectory.setEditable(false);
        JPanel filechooser = new JPanel(new GridLayout(1, 2));
        filechooser.add(choosedDirectory);
        JButton fchooserButton = new JButton("...");
        fchooserButton.setActionCommand("ChooseFile");
        fchooserButton.addActionListener(this);
        filechooser.add(fchooserButton);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Selected Directory"), filechooser));
    }

    @Override
    public void setBlockFile(String file) {
        this.directoryPath = file;
    }

    public DirectoryReader() {
        this("");
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getSource() instanceof JButton) {
            JButton source = (JButton) e.getSource();
            if (source.getActionCommand().equals("ChooseFile")) {
                fc = new JFileChooser();
                fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                fc.setAcceptAllFileFilterUsed(false);
                int returnVal = fc.showOpenDialog(null);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File dir = fc.getSelectedFile();
                    this.directoryConent = dir.listFiles(new JPEGFiler());
                    for (int i = 0; i < directoryConent.length; i++) {
                        if (directoryConent[i].isFile()) {
                            System.out.println("File " + directoryConent[i].getPath());
                        }
                    }
                    if (directoryConent.length > 0) {
                        hasInput = true;
                    } else {
                        hasInput = false;
                    }
                    directoryPath = fc.getSelectedFile().getPath();
                    choosedDirectory.setText(directoryPath);
                }

            }

        }
    }

    @Override
    public boolean hasInputs() {
        return this.hasInput;
    }

    public void processInput() {
        if (pos < directoryConent.length) {
            outputBus.writeToAll(directoryConent[pos].getPath());
            pos++;
        } else {
            hasInput = false;
        }
    }

    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);
        Attr dirP = doc.createAttribute("directoryPath");
        dirP.setValue(this.directoryPath);
        e.setAttributeNode(dirP);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        this.directoryPath = e.getAttribute("directoryPath");
    }

    @Override
    public void resetBlockState() {
        this.pos = 0;
    }

    @Override
    public void setLoadedSettings() {
        choosedDirectory.setText(this.directoryPath);
        File dir = new File(this.directoryPath);
        this.directoryConent = dir.listFiles(new JPEGFiler());
        if (directoryConent.length > 0) {
            hasInput = true;
        } else {
            hasInput = false;
        }
    }

    @Override
    public void finalizeBlockWork() {
    }

    class JPEGFiler implements FileFilter {

        public boolean accept(File f) {
            if (f.isDirectory()) {
                return false;
            }

            String s = f.getName();

            return s.endsWith(".jpg") || s.endsWith(".JPG");
        }
    }
}
