/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.source;

import baka.dataflow.*;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class LineReader extends DataBlock implements ActionListener {

    private String filePath = "";
    private String fileName = "";
    private JFileChooser fc;
    JTextField choosedFile;
    private boolean hasInput = true;
    FileInputStream fstream;
    InputStreamReader isr;
    BufferedReader r;

    public LineReader() {
        this.maxInputCount = 0;
        this.inputCount = 0;
        this.type = "LineReader";
        this.category = "source";
        this.description = "Reads file line by line.";
        constructProperties();
        this.propertiesPanel.setName(this.type);


        choosedFile = new JTextField(filePath);
        choosedFile.setEditable(false);
        JPanel filechooser = new JPanel(new GridLayout(1, 2));
        filechooser.add(choosedFile);
        JButton fchooserButton = new JButton("...");
        fchooserButton.setActionCommand("ChooseFile");
        fchooserButton.addActionListener(this);
        filechooser.add(fchooserButton);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Selected File"), filechooser));

    }

    @Override
    public void setBlockFile(String file){
        this.filePath = file;
    }

    private void initializeFile() {
        try {
            fstream = new FileInputStream(this.filePath);
            isr = new InputStreamReader(fstream);
            r = new BufferedReader(isr);
        } catch (Exception e) {//Catch exception if any
            System.err.println("Error: " + e.toString());
            JOptionPane.showMessageDialog(null, "Error on "+this.type+"\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            this.hasInput = false;
            return;
        }
        this.hasInput = true;
    }

    @Override
    public boolean hasInputs() {
        return this.hasInput;
    }

    public void processInput() {
        try {
            String line = "";
            if ((line = r.readLine()) != null) {
                System.out.println("precital som riadok: " + line);
                outputBus.writeToAll(line);
            } else {
                //Close the input stream
                System.out.println("Som na konci zatvaram streamy.");
                this.hasInput = false;
                r.close();
                isr.close();
                fstream.close();
            }
        } catch (Exception e) {//Catch exception if any
            System.err.println("Process input Error: " + e.getMessage());
            e.printStackTrace();
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getSource() instanceof JButton) {
            JButton source = (JButton) e.getSource();
            if (source.getActionCommand().equals("ChooseFile")) {
                fc = new JFileChooser();
                int returnVal = fc.showOpenDialog(null);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File file = fc.getSelectedFile();
                    this.filePath = file.getPath();
                    this.fileName = file.getName();
                    choosedFile.setText(file.getName());
                }

            }

        }

    }

    public String getFilePath() {
        return filePath;
    }

    public String getFileName() {
        return fileName;
    }

    @Override
    public Element getXML(Element e, Document doc) {
        e = super.getXML(e, doc);
        Attr file = doc.createAttribute("fileName");
        file.setValue(this.fileName);
        e.setAttributeNode(file);

        Attr fileP = doc.createAttribute("filePath");
        fileP.setValue(this.filePath);
        e.setAttributeNode(fileP);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        this.fileName = e.getAttribute("fileName");
        this.filePath = e.getAttribute("filePath");
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.choosedFile.setText(this.fileName);
    }

    @Override
    public void resetBlockState() {
        initializeFile();
    }

    @Override
    public void finalizeBlockWork() {
    }
}
