/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.gui;

import baka.main.Config;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.TransferHandler;

/**
 *
 * @author madda
 */
public class PalleteBlock extends JPanel implements MouseMotionListener {

    String type;

    public PalleteBlock(String type) {
        this.type = type;
        this.setPreferredSize(new Dimension(Config.BlockWidth, Config.BlockHeight));
        this.addMouseMotionListener(this);
        //this.setBorder(BorderFactory.createLineBorder(Color.BLACK));
    }

    public String getType() {
        return this.type;
    }

    @Override
    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g.create();
        BufferedImage bi = null;

        try {
            String specificImageLocation = "blocks/" + this.type.replace('.', '/') + ".gif";
            java.net.URL imgURL = getClass().getResource(specificImageLocation);
            try{
            bi = ImageIO.read(imgURL);
            }catch(IllegalArgumentException iae){

            }
        } catch (IOException ex) {
            Logger.getLogger(PalleteBlock.class.getName()).log(Level.SEVERE, null, ex);
        }
        if (bi == null) {
            String defaultImageLocation = "blocks/" + this.type.substring(0, this.type.indexOf(".")) + "/blok.gif";
            try {
                java.net.URL imgURL = getClass().getResource(defaultImageLocation);
                bi = ImageIO.read(imgURL);
            } catch (IOException ex) {
                Logger.getLogger(PalleteBlock.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        if (bi != null) {
            g2.drawImage(bi, 0, 0, null);
        }
        g2.setColor(Color.BLUE);
        g2.setFont(new Font(Font.SERIF, Font.BOLD, 13));
        g2.drawString(this.type.substring(this.type.indexOf(".") + 1), 5, 25);
        g2.dispose();
    }

    public void mouseDragged(MouseEvent e) {
        JComponent c = (JComponent) e.getSource();
        TransferHandler handler = c.getTransferHandler();
        //Tell the transfer handler to initiate the drag.
        handler.exportAsDrag(c, e, TransferHandler.COPY);
    }

    public void mouseMoved(MouseEvent e) {
    }
}
